# BEGIN SourceDeps(oneline):
BuildRequires: /usr/sbin/install-info gcc-c++ libmpe2-devel libreadline-devel perl(FileHandle.pm) python-devel
# END SourceDeps(oneline)
%add_findprov_skiplist %_libdir/Yap/*
%add_findreq_skiplist %_libdir/Yap/*
%add_findreq_skiplist /usr/share/Yap/*
# BEAM is experimantal and some interpreter code unimplemented. See
# README.EAM.html for more details.
%global use_eam 0

Name:       yap
Version:    6.2.2
Release:    alt1_7
Summary:    High-performance Prolog Compiler
Group:      Development/Other
# README                            Perl Artistic license 2 and the FSF's LGPL
# packages/ProbLog/                         Artistic 2.0
# COPYING                                   LGPL
# LGPL/pillow/pillow.pl                     LGPLv2+
# packages/clib/sha1/sha2.c                 BSD or GPL
# packages/http/examples/demo_threads.pl    GPLv2+
License:    Artistic 2.0 and LGPLv2+ and (BSD or GPL+) and (GPLv2+)
URL:        http://www.ncc.up.pt/~vsc/Yap/
Source:     %{url}%{name}-%{version}.tar.gz
Patch1:     Yap-noni386.patch
Patch2:     yap-6.2.0-Locate-mysql-by-mysql_config.patch
Patch3:     yap-6.2.0-Install-directory-for-info-pages.patch
Patch4:     yap-6.2.0-Install-http-CSS-files-into-PLTARGET.patch
Patch5:     yap-6.2.0-Do-not-install-README-etc.patch
Patch6:     yap-6.2.0-Install-info-pages-non-executable.patch
Patch7:     yap-6.2.0-Do-not-install-info-dir-index.patch
# fix non-x86 build with recent gcc
Patch8:     yap-6.2.0-gprof-macro.patch
# Fix compilation of PLStream package on PPC
Patch9:     yap-6.2.0-Remove-feature-macro.patch
# Reported to upstream <yap-users@lists.sourceforge.net>
Patch10:    yap-6.2.2-Off-by-one-error-when-initializing-yap_flags.patch
# yap 6.2.2 does not work on PPC (bug #790625)
# Reported to upstream <yap-users@lists.sourceforge.net>
Patch11:    yap-6.2.2-Texinfo-5-does-not-allow-bullet-as-table-indicator.patch
ExcludeArch:    ppc ppc64
BuildRequires:  autoconf
# Update config.sub to support aarch64, bug #926852
BuildRequires:  automake
BuildRequires: libgmp-devel libgmp_cxx-devel
BuildRequires:  libmysqlclient-devel
# TODO: BuildRequires:  openmpi-devel
BuildRequires:  readline-devel
BuildRequires:  texinfo
BuildRequires:  libunixODBC-devel
BuildRequires:  zlib-devel

# Do not export provides and requires on private libraries

%filter_from_requires /^libplstream.so(/d

Source44: import.info
%add_findprov_skiplist /usr/lib64/Yap/*

%description
A high-performance Prolog compiler developed at LIACC, Universidade do
Porto. The Prolog engine is based in the WAM (Warren Abstract
Machine), with several optimizations for better performance. YAP
follows the Edinburgh tradition, and is largely compatible with the
ISO-Prolog standard and with Quintus and SICStus Prolog.


%package devel
Summary:    C-Interface development files for Yap
Group:      Development/Other
Requires:   %{name} = %{version}-%{release}

%description devel
C-Interface development files for Yap.


%package docs
Summary:    Documentation for Yap
Group:      Development/Other
BuildArch:  noarch
Requires:   %{name} = %{version}-%{release}

%description docs
Documentation for Yap.


%prep
%setup -q
%patch1 -p1
%patch2 -p1 -b .mysql_config
%patch3 -p1 -b .install_info_directory
%patch4 -p1 -b .install_css_into_pltarget
%patch5 -p1 -b .do_not_install_readme
%patch6 -p1 -b .non_executable_info
%patch7 -p1 -b .do_not_install_info_index
%patch8 -p1 -b .macro
%patch9 -p1 -b .remove_feature_macro
%patch10 -p1 -b .initialization
%patch11 -p1 -b .texinfo5

# remove redundant RPATH
sed -i 's/-Wl,-R\(,\)\{0,1\}\\$(LIBDIR)//' configure.in
# transform RPATH into RUN_PATH. Private libraries dlopen()ed depend each on
# other
sed -i 's/-Wl,-R/-Wl,--enable-new-dtags,-R/g' configure.in
# Add soname to library
sed -i -e 's/\(-soname=\$DYNYAPLIB\)/\1.%{version}/' configure.in

# Update config.sub to support aarch64, bug #926852
#cp -p %{_datadir}/automake-*/config.{sub,guess} .
#cp -p %{_datadir}/automake-*/config.{sub,guess} packages/jpl
# Regerenate configure because of patching
autoconf

# chr and clpqr are optional and they are a copy from SWI Prolog (LGPLv2+)
# TODO: Unbundle chr and clpqr libraries as subpackages

# Add soname to library and symlink from unversioned to versioned one
sed -i \
    -e '/@YAPLIB_LD@/ s/\(-o @YAPLIB@\)\(.*\)/\1.%{version}\2\n\tln -s @YAPLIB@.%{version} @YAPLIB@/' \
    -e '/@INSTALL_DLLS@.* @YAPLIB@/ s/\(@YAPLIB@\)\(.*\)/\1.%{version}\2\n\t@LN_S@ @YAPLIB@.%{version} $(DESTDIR)$(LIBDIR)\/@YAPLIB@/' \
    Makefile.in

# Fix file encoding
for F in README changes.css; do
    tr -d '\r' < "$F" > "${F}.new"
    touch -r "$F"{,.new}
    mv "$F"{.new,}
done
for F in docs/yap.tex TO_DO; do
    iconv -f iso-8859-1 -t utf-8 < "$F" > "${F}.new"
    sed -i -e '/mode: texinfo/ s/\(coding: \)latin-1/\1utf-8/' "${F}.new"
    touch -r "$F"{,.new}
    mv "$F"{.new,}
done

# Fix file permissions
chmod -x COPYING packages/http/examples/demo_inetd
# Permissions for debuginfo content
find -name '*.h' -exec chmod 0644 '{}' ';'
find -name '*.c' -exec chmod 0644 '{}' ';'


%build
# % define optflags $(echo $RPM_OPT_FLAGS | sed 's|-fstack-protector||')
%configure \
    --enable-coroutining \
    --enable-max-performance \
    --enable-depth-limit \
    --enable-dynamic-loading \
    --enable-myddas \
%if %{use_eam}
    --enable-eam \
%endif
    --enable-chr \
    --enable-clpqr
# TODO: --with-java

make %{?_smp_mflags}
make %{?_smp_mflags} info


%install
make DESTDIR=$RPM_BUILD_ROOT install
make DESTDIR=$RPM_BUILD_ROOT install_info

# fix permissions and flags
chmod 0644 $RPM_BUILD_ROOT%{_datadir}/Yap/pl/*
chmod 0644 $RPM_BUILD_ROOT%{_includedir}/Yap/*

# Move installed examples to docs dir
%global documentation docs-documentation
for P in clpbn; do 
    mkdir -p "%{documentation}/examples/${P}"
    mv "$RPM_BUILD_ROOT%{_datadir}/Yap/${P}/examples/"* \
        "%{documentation}/examples/${P}"
    rmdir "$RPM_BUILD_ROOT%{_datadir}/Yap/${P}/examples"
done
for P in minisat problog; do 
    mkdir -p "%{documentation}/examples/${P}"
    mv "$RPM_BUILD_ROOT%{_datadir}/Yap/${P}_examples/"* \
        "%{documentation}/examples/${P}"
    rmdir "$RPM_BUILD_ROOT%{_datadir}/Yap/${P}_examples"
done
# Copy not-installed examples to docs dir
# CLPBN/*, swi-minisat2 installed already
# TODO: jpl documentation with java support
# TODO: mpi documentation with mpi support
for P in pyswip cplint http plunit; do 
    mkdir -p "%{documentation}/examples/${P}"
    cp -a "packages/${P}/examples/"* "%{documentation}/examples/${P}"
done
for P in LGPL/pillow; do 
    mkdir -p "%{documentation}/examples/${P}"
    cp -a "${P}/examples/"* "%{documentation}/examples/${P}"
done

# Remove empty files
for F in $RPM_BUILD_ROOT%{_datadir}/Yap/myddas_top_level.yap \
    %{documentation}/examples/cplint/coin.uni; do
    test -s "$F" || rm "$F"
done


%files
%doc Artistic changes* COPYING GIT README TO_DO
%if %{use_eam}
%doc README.EAM.html
%endif
%{_bindir}/yap
%{_datadir}/Yap
%{_libdir}/Yap
%{_libdir}/libYap.so.*
%{_infodir}/*


%files devel
%{_libdir}/libYap.so
%{_includedir}/Yap


%files docs
%doc LGPL/pillow/doc/pillow_doc_html/*
%doc LGPL/pillow/doc/article.ps.gz
%doc %{documentation}/*


%changelog
* Wed Apr 10 2013 Igor Vlasenko <viy@altlinux.ru> 6.2.2-alt1_7
- update to new release by fcimport

* Wed Feb 27 2013 Igor Vlasenko <viy@altlinux.ru> 6.2.2-alt1_6
- update to new release by fcimport

* Mon Jan 14 2013 Igor Vlasenko <viy@altlinux.ru> 6.2.2-alt1_5
- update to new release by fcimport

* Thu Aug 02 2012 Igor Vlasenko <viy@altlinux.ru> 6.2.2-alt1_4
- update to new release by fcimport

* Fri Jun 08 2012 Igor Vlasenko <viy@altlinux.ru> 6.2.2-alt1_3
- fc import

